#include "stdafx.h"

class C3DPoint// : public CObject
{
public:
	double m_x, m_y, m_z;
	//double m_lat, m_lon;
};

#define MOVETO	0
#define DRAWTO	1

class CDrawSeq// : public CObject
{
public:
	double m_lat, m_lon;
	double m_z;
	int	m_mode;
};


class CRefPoint : public CObject
{
public:
	void Rotate(double &x, double &y);
	void SetRotate(double rot);
	UINT GetLineNum(void);
	double CalcMinDist(double lat, double lon);
	void SetPointsOrigin(int origin);
	void AddPoint(double x, double y, double z);
	void SetLatLon(const char *lat, const char *lon);
	void SetLatLon(double lat, double lon);
	CRefPoint(void);
	~CRefPoint();
	void DeletePoints(void);
	void SetScale(double scale);
	void SetLineNum(UINT linenum);

	// draw sequence ̓o^
	void AddMoveToPt(int n);
	void AddDrawToPt(int n);
	void AddMoveTo(double x, double y, double z);
	void AddDrawTo(double x, double y, double z);

	// draw
	void Draw(CDC *pDC, double latorg, double lonorg, double MeterPerPixel, BOOL checked = FALSE);

protected:
	void AddDrawSeq(double lat, double lon, double z, int mode);

	double m_lat;	// RefPoint ʒu
	double m_lon;
	double m_scale;

	double m_rot;	// ]p
	double m_cos;
	double m_sin;

	int m_nLineNum;	// bgs t@C̍sԍ

	int m_nPoint;	// Points
	int m_PtOrigin;
	
	int m_nDrawPoint;
	CArray<C3DPoint, C3DPoint&>	m_points;
	CArray<CDrawSeq, CDrawSeq&>	m_drawseq;
};
